commit 9680dfad5a495c8ea1ee7db714fcec715bfa0fed
Author: Anton A. Melnikov <a.melnikov@postgrespro.ru>
Date:   Sun Jul 23 22:24:03 2023 +0300

    Don't allow LimitAdditionalPins() to return zero.
    
    Reported-by Victoria Shepard.

diff --git a/src/backend/storage/buffer/bufmgr.c b/src/backend/storage/buffer/bufmgr.c
index a7e3b9bb1d..df22aaa1c5 100644
--- a/src/backend/storage/buffer/bufmgr.c
+++ b/src/backend/storage/buffer/bufmgr.c
@@ -1767,7 +1767,7 @@ LimitAdditionalPins(uint32 *additional_pins)
 	 */
 	max_proportional_pins -= PrivateRefCountOverflowed + REFCOUNT_ARRAY_ENTRIES;
 
-	if (max_proportional_pins < 0)
+	if (max_proportional_pins <= 0)
 		max_proportional_pins = 1;
 
 	if (*additional_pins > max_proportional_pins)
